Redmine - Defect #17517

Attempting to Add a Related Issue Multiple Times Sequentially Causes 500
2014-07-21 18:59 - Zach Auclair

Status: Closed Start date:

Priority: Normal Due date:

Assignee: % Done: 0%
Category: ul Estimated time: 0.00 hour
Target version: 4.0.0

Resolution: Fixed Affected version: 2.5.1
Description

When pressing "Add" after typing a related issue, the form ajax submits but does not prevent further ajax submits while the request is
being processed.

As a result of this, clicking "add" multiple times quickly will cause sequential requests to link an issue (after the first) to fail; along with
this, the results of the last post are displayed (meaning the first successful add of a related issue may be hidden).

proposed patch:

diff --git a/app/views/issue_relations/_form.html.erb b/app/views/issue_relations/_form.html.erb
index 29b7f0f..ff80e47 100644
-—— a/app/views/issue_relations/_form.html.erb
+++ b/app/views/issue_relations/_form.html.erb
@@ -5,7 +5,7 @@
<span id="predecessor_fields" style="display:none;">
<%= 1l (:field_delay) %>: <%= f.text_field :delay, :size => 3 %> <%= 1l (:label_day_plural) %>
</span>
—-<%= submit_tag 1 (:button_add) %>
+<%= submit_tag 1l (:button_add), :disable_with => 1 (:button_add) %>
<%= link_to_function 1 (:button_cancel), 'S$("#new-relation-form").hide(); '%>

</

>

e}

Related issues:
Related to Redmine - Feature #23630: Migrate to Rails 5.2 Closed

History

#1 - 2014-08-19 05:37 - Toshi MARUYAMA

- Target version set to 2.5.3

#2 - 2014-08-19 05:43 - Toshi MARUYAMA
- Target version changed from 2.5.3 to 2.6.0

#3 - 2014-08-19 05:44 - Toshi MARUYAMA

https://github.com/plataformatec/devise/issues/2343#issuecomment-15334387

DEPRECATION WARNING: :disable_with option is deprecated and will be removed from Rails 4.1. Use 'data: { disable_with: 'Text' }' instead.

#4 - 2014-09-14 12:52 - Jean-Philippe Lang
- Status changed from New to Needs feedback

- Assignee set to Jean-Philippe Lang

The proposed fix has a side effect with Firefox (tested with 24 ESR):
1.go to an issue, add a relation

2. hit F5
3. click on the 'Add' link to add another relation => the 'Add' button is disabled
https://github.com/plataformatec/devise/issues/2343#issuecomment-15334387

Problem doesn't occur if step 2 is omitted.

BTW, I don't get 500 errors when hitting the button multiple times. | only get a proper validation error message. Can you post your 500 error stack
trace ?

#5 - 2014-10-18 12:17 - Jean-Philippe Lang

- Target version changed from 2.6.0 to Candidate for next minor release
#6 - 2018-03-22 23:40 - Marius BALTEANU
It seems that the data-disable-with attribute is enabled by default in Rails 5. There are some examples here.

Also, | tested this issue on the current trunk and works as expected in the major browsers (Safari, Chrome and Firefox) on OS X. | propose to mark
this ticket as fixed by #23630.

#7 - 2018-03-22 23:40 - Marius BALTEANU
- Related to Feature #23630: Migrate to Rails 5.2 added

#8 - 2018-05-15 00:00 - Marius BALTEANU
- Assignee deleted (Jean-Philippe Lang)

- Target version changed from Candidate for next minor release to 4.0.0

Considering that the issue seems to be fixed in version 4.0.0 by the migration to Rails 5.1, | would like a second opinion before closing it.

#9 - 2018-06-16 12:48 - Jean-Philippe Lang
- Status changed from Needs feedback to Closed

- Resolution set to Fixed

Works for me
http://api.rubyonrails.org/v5.1.3/classes/ActionView/Helpers/FormTagHelper.html#method-i-submit_tag
https://www.redmine.org/issues/23630
https://www.redmine.org/versions/99
